<template>
  <div>
    <div>
<CModal
            title="Info"
      size="sm"
      :show.sync="smallModal">
      {{ SuccessMsg }}

</CModal>


<CCardBody>
     <h5>Trace Hold Release</h5>
           <form class="form-inline">
  
   <h6> Barcode</h6>
  <div class="form-group mx-sm-2 mb-2">
    
   <input v-model="searchid">
   
  </div>  
  
  
   <CButton size="sm" color="dark" class="ml-1" @click="getHoldDetails(searchid) ;ShowUpdateModal= true;"> Search </CButton>
  
</form>
    <!-- <CDataTable
      :items="items"
      :fields="fields"
      table-filter
      items-per-page-select
      :items-per-page="5"
      pagination
      hover
      striped
      border
     >
    -->

<!--Adding Customs buttons to each row -->
    <!-- <template #show_details="{item}" >      
      <CButton size="sm" color="info" class="ml-1" @click="ShowDetailsModal=true; Select(item)"> Details </CButton>
      <CButton size="sm" color="dark" class="ml-1" @click="ShowUpdateModal=true; Select(item)"> Release </CButton>
    </template>

    </CDataTable> -->
    
  </CCardBody>

 </div>



<!-- Show Update Modal -->

<div id="overlay" v-if="ShowUpdateModal">
<div class="modal-dialog  modal-lg" >
<div class="modal-content">
  <div class="modal-header" >    
    <h5 class="modal-title">Release Tread </h5>
      <span> </span>
    
   <h6 class="modal-title">- Div User Name / Id</h6>
    <button type="button" class="close"  @click="ShowUpdateModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
<div class="modal-body modal-lg">

<form >



  <div>
        <!-- <CListGroupItem href="#" color="secondary"> -->
    <CRow>
       <CCol sm="2" > Tread Code</CCol>
      <CCol sm="3">
        <CInput
          readonly
          v-model = this.items.material_Code
        />
      </CCol>
       <CCol sm="2" >Color Code</CCol>
      <CCol sm="3">
        <CInput
          readonly
          v-model = this.items.size_Code
        />
      </CCol>
    </CRow>

     <CRow>
       <CCol sm="2" >Leaf Truck</CCol>
      <CCol sm="3">
       <select class="form-control" v-model="CurrentHoldrelease.mhE_Id">
    <!-- <option value= "Select Material Type" selected disabled>Select Material Type</option> -->
    <option v-for="mitem in mheitems" :value="mitem.mhE_Id" :key="mitem.mhE_Id">{{ mitem.mhE_Name }} </option>
  </select>
      </CCol>
       <CCol sm="2" >Location</CCol>
      <CCol sm="3">
       
         <select class="form-control" v-model="CurrentHoldrelease.storage_Loc_Id"  >   
              <option v-for="switem in swlocitems" :value="switem.storage_Loc_Id" :key="switem.storage_Loc_Id">{{ switem.storage_Loc_Name }}</option>
           </select>  
      
      </CCol>
    </CRow>

      <CRow>
      
      <CCol sm="2" > Quantity</CCol>
      <CCol sm="3">
        <CInput
        placeholder= this.items.quantity
         v-model  = CurrentHoldrelease.realesed_Count
        />
      </CCol>
          <CCol sm="2" >Truck Number</CCol>
     
        <CCol sm="3">
  <CInput
  readonly
  placeholder="1"
 />
      </CCol>
    </CRow>


       <CRow>
      
   
    </CRow>
       <CRow>
   
      <!-- <CCol sm="2" >  Ageing Period</CCol>
      <CCol sm="3">
        <CInput
         readonly
         v-model   = this.Currentproductiondetails.ageing_Time
        />
      </CCol> -->
 <!-- <CCol sm="1" > Age</CCol>
      <CCol sm="5">
        <CInput
          readonly
         v-model= this.items.currentAge
        />
      </CCol> -->
    </CRow>
        <CRow>
           <CCol sm="6">
              </CCol>
           <!-- <CCol sm="2">
        <CInput
         readonly
        v-model   = this.items.ageStatus
        />
      </CCol> -->
     
     
    </CRow>
      <CListGroupItem href="#" color="secondary">
   <CRow>
       
   
      
         <CCol sm="2">
        <CButton size="sm" color="warning" class="ml-1" @click="  addtoHoldRelease();"> Print</CButton>
         </CCol>
          
    <CCol sm="2">
          </CCol>
        <CCol sm="2">
          
      </CCol>
     
    </CRow>
     </CListGroupItem> 
  </div>

</form>

</div>
</div>
</div>
</div>

</div>
</template>

<script>
 const apigetsw =  'Trace_Storage_Location_Master/'
 const apiprodurl =  'Trace_Production/GetTrace_HoldProductionForBarcode/'
 const apiget =  'Trace_Hold/'
 const apiurl =  'Trace_Hold_Release/'
const items = [
  { key: 'hold_Id', _style:'min-width:200px' },
  { key: 'production_ID', _style:'min-width:100px;' },
  { key: 'hold_Reason_Id', _style:'min-width:50px;' }, 
  { key: 'hold_By',     _style: 'width:1%',  },
  { key: 'hold_Time',     _style: 'width:1%',  },
  { key: 'hold_Date',     _style: 'width:1%',  },
 ]   
 
//import CTableWrapper from '.@/Table.vue' 
import Vue from 'vue'
import axios from 'axios'
import VUEAxios from 'vue-axios'
Vue.use(VUEAxios,axios)

export default {
   //components: { CTableWrapper },
  data ()
  {
     return {
    items: items.map((item, id) => { return {...item, id}}),
    
     fields: [
       // { key: 'show_details1',  label: '',  _style: 'width:1%', },
            
              { key: 'hold_Id' , label: 'Hold Id',},
              { key: 'production_ID', label: 'Production ID',},
              { key: 'hold_Reason_Id', label: 'Hold Reason Id',  },             
              { key: 'hold_By',  label: 'Hold By',  _style: 'width:12%', },
              //{ key: 'Holditem_CreationDate',  label: 'Holditem Creation Date',  _style: 'width:12%', },
              { key: 'hold_Time',  label: 'Hold Time',  _style: 'width:12%', },
              { key: 'hold_Date',  label: 'Hold Date',  _style: 'width:12%', },
              { key: 'show_details',  label: '',  _style: 'width:35%', },     
      ],
  mheitems:[],
  Reasonitems:[],
  searchid:""  ,
  details: [],
  collapseDuration: 0,
  errMsg:"",
  SuccessMsg:"",
  ShowAddModal:"",
  ShowDeleteModal:"",
  CurrentHolditem:"",
  ShowUpdateModal:"",
  ShowDetailsModal:"",
   locSW:"",
  swlocitems:"",
  smallModal: false,
  CurrentHoldrelease:{
  hold_Release_Id: 0,  hold_Id: 0,  realesed_By: "",  realesed_Count: 0, hold_Reason_Id:0, released_Time:new Date(),  realesed_date: new Date(),  released_Reason: "",mhE_Id:0,  status: 1,barcodeId:0},
  newHolditem: "", 
  
  }
  },
  

  
  mounted()
  {
  
 
  },

  methods:
  {
   getAllHolditemDetails: function()
   {
  
   Vue.axios.get(this.$url+ apiget+searchid)
    .then((response)=>{
   
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
        this.items = response.data.filter(x => x.hold_Status == 1);
       
       //this.subitems = response.data.fgS_FIFO_Holditem_Type_Master;

       }
    });
   },

   
  getAllMHEDetails: function(mhe)
   {
   
   Vue.axios.get(this.$url+'Trace_MHE_Master/')
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
         
        this.mheitems =response.data.filter(x => x.mhE_Status == 0 && x.mhE_Type == mhe);
console.log(this.mheitems)
       // this.subitems = response.data.fgS_FIFO_MHE_Type_Master;
       }
    });
   },
  getHoldDetails: function(searchid)
   {
 // alert(this.$url + apiprodurl + searchid)
   Vue.axios.get(this.$url + apiprodurl + searchid)
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
      else if(response.data.length == 0)
     {
     this.SuccessMsg = "No Hold Data Available for searched Barcode "
      this.smallModal = true;
      this.ShowUpdateModal =  false;

     }
    else
       {
     
        this.items =response.data[0]//.filter(x => x.hold_Status == 0);
        //console.log(this.items.workCent_Id)
        if (this.items.material_Code.includes("SW"))
        {
       ;
        this.getAllMHEDetails("SW"); 
         this.getAllStorageLocDetails(this.items.workCent_Id);
         }
       else 
          {
      
         this.getAllMHEDetails("LeafTruck"); 
          this.getAllStorageLocDetails(this.items.workCent_Id);
            }
        console.log( response.data)

       }
    });
   },

 addtoHoldRelease()
  {

  this.CurrentHoldrelease.realesed_By= 1111;
  this.CurrentHoldrelease.released_Time= new Date().toLocaleTimeString() ,
  this.CurrentHoldrelease.realesed_date= new Date().toISOString().slice(0,10),
  this.CurrentHoldrelease.barcodeId= this.items.barcode_Id;
  if(this.CurrentHoldrelease.realesed_Count <=0 || this.CurrentHoldrelease.mhE_Id <=0)
   {
      this.SuccessMsg ="Please enter Quantity/ Select Leaf Truck.."
      this.smallModal = true;

   }
    else
    {
  Vue.axios.post(this.$url + apiurl,this.CurrentHoldrelease).then((response)=>{
   
  
   
   //Vue.axios.put(this.$url + 'Trace_Hold_Release/'+ this.CurrentHolditem.hold_Id, this.CurrentHoldrelease).then((response)=>{
       if(response.data.error)
       {
          alert('Data Error')
       }
      else if(response.data == "1")
       {
         
       this.SuccessMsg = " Hold status aleady updated to OK for the item in searched Barcode  "+ this.CurrentEntry.mhename 
       this.smallModal = true;

       }

       else
       {
        // alert("2");
         this.SuccessMsg ="Tag printing in progress.."
         this.smallModal = true;
         //this.getAllHolditemDetails();
       }
    })
  }
   },
   getAllStorageLocDetails: function(wcid)
   {

   Vue.axios.get(this.$url+ apigetsw )
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
        // alert(this.searchdata.dualid)
        this.swlocitems = response.data.filter(x => x.storage_Loc_Status == 1 && x.workCent_Id == wcid);
       console.log(response.data)
       // this.subitems = response.data.fgS_FIFO_StorageLoc_Type_Master;

       }
    });
   },
      
   Select(Holditem)
    {
     this.CurrentHolditem = Holditem;
     
    },

      
 issw()
  {
     
      if (this.items.material_Code.includes("SW"))
      { alert("y"); return true;   }
       else 
      {    return false;  }
    },
 
      
  }

}
</script>

<style scoped>
#overlay{
  position:fixed;
  top:100px;
  bottom:0;
  left:0;
  right:0;
  background:rgba(0,0,0,0.6);
}
</style>